# info.py
# Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#   $Id: info.py,v 1.3 2002/05/14 14:16:59 sjah Exp $
#

"""Some kind of information about alsaplayer state."""

__author__ = "Evgeny Chukreev <codedj@echo.ru>"
__date__ = "$Date: 2002/05/14 14:16:59 $"
__version__ = "$Revision: 1.3 $"
__license__ = "GNU"
 
import aptk.misc, alsaplayer, gtk, GTK

class StreamTypeLabel (gtk.GtkLabel):
    def __init__ (self, cp):
	gtk.GtkLabel.__init__ (self, "")
	
	self.__cp = cp

	# Start timeout which will update label
	self.__timeout = gtk.timeout_add (200, self.__cb_timeout)

    def __cb_timeout (self):
	self.set_text (self.__cp.get_stream_info ().stream_type)

	return 1


class TimeLabel (gtk.GtkLabel):
    def __init__ (self, cp):
	gtk.GtkLabel.__init__ (self, "")
	
	self.__cp = cp

	# Start timeout which will update label
	self.__timeout = gtk.timeout_add (500, self.__cb_timeout)

    def __cb_timeout (self):
	frames = self.__cp.get_frames ()

	played = self.__cp.get_current_time () / 100
	m, s = divmod (played, 60)

	total = self.__cp.get_current_time (frames) / 100
	t_m, t_s = divmod (total, 60)
	
	self.set_text ("%02u:%02u/%02u:%02u" % (m, s,  t_m, t_s))

	return 1


class FullStatusHBox (gtk.GtkHBox):
    def __init__ (self, cp):
	gtk.GtkHBox.__init__ (self)

	self.stream_type_label = StreamTypeLabel (cp)
	self.time_label = TimeLabel (cp)

	self.stream_type_label.set_justify (GTK.JUSTIFY_LEFT)
	self.time_label.set_justify (GTK.JUSTIFY_RIGHT)

	self.pack_start (self.stream_type_label, expand=GTK.FALSE)
	self.pack_end (self.time_label, expand=GTK.FALSE, fill=GTK.TRUE)
