# speed.py
# Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#   $Id: speed.py,v 1.1 2002/05/11 00:01:09 sjah Exp $
#
 
__author__ = "Evgeny Chukreev <codedj@echo.ru>"
__date__ = "$Date: 2002/05/11 00:01:09 $"
__version__ = "$Revision: 1.1 $"
__license__ = "GNU"

import alsaplayer, gtk, aptk.misc, GTK

# - - - - - - - - Scale --------------------------------------------------
class _Scale:
    def __init__ (self, cp):
	adj = gtk.GtkAdjustment (value=cp.get_speed()*100, lower=-333, upper=333)
	adj.connect ("value_changed", self.__cb_speed_changed)
	self.set_adjustment (adj)

	self.set_draw_value (0)

	self.__cp = cp

    def __cb_speed_changed (self, w):
	self.__cp.set_speed (w.value/100);

class HScale (gtk.GtkHScale, _Scale):
    def __init__ (self, cp):
	gtk.GtkHScale.__init__ (self)
	_Scale.__init__ (self, cp)


class VScale (gtk.GtkVScale, _Scale):
    def __init__ (self, cp):
	gtk.GtkVScale.__init__ (self)
	_Scale.__init__ (self, cp)


# - - - - - - - - - Button ---------------------------------------------------
class Button (aptk.misc.Button):
    def __init__ (self, cp, value, **keys):
	aptk.misc.Button.__init__ (self, **keys)
	self.connect ("clicked", self.__cb_clicked)
	self.__value = value
	self.__cp = cp


    def __cb_clicked (self, w):
	self.__cp.set_speed (self.__value)


# - - - - - - - - - - - - - - - Boxes - - - - - - - - - -
class _Box:
    def __init__ (self, cp, pause_label=None, pause_xpmfile=None,
			    backward_label=None, backward_xpmfile=None,
			    forward_label=None, forward_xpmfile=None, **keys):
				
	self.backward_button = Button (cp, -1, label=backward_label, xpmfile=backward_xpmfile, **keys)
	self.add (self.backward_button)

	self.pause_button = Button (cp, 0, label=pause_label, xpmfile=pause_xpmfile, **keys)
	self.add (self.pause_button)

	self.forward_button = Button (cp, 1, label=forward_label, xpmfile=forward_xpmfile, **keys)
	self.add (self.forward_button)


class HBox (gtk.GtkHBox, _Box):
    def __init__ (self, cp, **keys):
	gtk.GtkHBox.__init__ (self)
	_Box.__init__ (self, cp, **keys)


class VBox (gtk.GtkVBox, _Box):
    def __init__ (self, cp, **keys):
	gtk.GtkVBox.__init__ (self)
	_Box.__init__ (self, cp, **keys)

# -  - - - - - - - - - - - - Final Widgets - - - - - - - - - - - - - - -
class HSpeed (gtk.GtkHBox):
    def __init__ (self, cp, **keys):
	gtk.GtkHBox.__init__ (self)
	
	self.pack_start (HBox (cp, **keys), expand = GTK.FALSE)
	self.add (HScale (cp))

class VSpeed (gtk.GtkVBox):
    def __init__ (self, cp, **keys):
	gtk.GtkVBox.__init__ (self)
	
	self.pack_start (VBox (cp, **keys), expand = GTK.FALSE)
	self.add (VScale (cp))
