# volume.py
# Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#   $Id: volume.py,v 1.1 2002/05/11 00:01:09 sjah Exp $
#
 
__author__ = "Evgeny Chukreev <codedj@echo.ru>"
__date__ = "$Date: 2002/05/11 00:01:09 $"
__version__ = "$Revision: 1.1 $"
__license__ = "GNU"

import alsaplayer, gtk, aptk.misc

# - - - - - - - - Scale --------------------------------------------------
class _Scale:
    def __init__ (self, cp):
	adj = gtk.GtkAdjustment (value=cp.get_volume(), lower=0.0, upper=100)
	adj.connect ("value_changed", self.__cb_volume_changed)
	self.set_adjustment (adj)
	
	self.set_draw_value (0)

	self.__cp = cp

    def __cb_volume_changed (self, w):
	self.__cp.set_volume (w.value);


class HScale (gtk.GtkHScale, _Scale):
    def __init__ (self, cp):
	gtk.GtkHScale.__init__ (self)
	_Scale.__init__ (self, cp)


class VScale (gtk.GtkVScale, _Scale):
    def __init__ (self, cp):
	gtk.GtkVScale.__init__ (self)
	_Scale.__init__ (self, cp)

# - - - - - - - - - Button ---------------------------------------------------
class Button (aptk.misc.Button):
    def __init__ (self, cp, value, **keys):
	aptk.misc.Button.__init__ (self, **keys)
	self.connect ("clicked", self.__cb_clicked)
	self.__value = value
	self.__cp = cp

    def __cb_clicked (self, w):
	self.__cp.set_volume (self.__value)

# - - - - - - - - - - - - - Final Widgets - - - - - - - - - - - - - - -
HVolume = HScale
VVolume = VScale
