#!/usr/local/bin/alsaplayer-python -I
# gtkplayer.py
# Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#   $Id: gtkplayer.py,v 1.2 2002/05/13 00:27:43 sjah Exp $
#
 
__author__ = "Evgeny Chukreev <codedj@echo.ru>"
__date__ = "$Date: 2002/05/13 00:27:43 $"
__version__ = "$Revision: 1.2 $"
__license__ = "GNU"

import alsaplayer, aptk, gtk, GTK

pl = alsaplayer.get_playlist ()
cp = pl.get_coreplayer ()

##########################################################
# Main window for test
def delete_event (foo, bar):
    gtk.mainquit ();

win = gtk.GtkWindow ()
win.connect ("delete_event", delete_event)

##########################################################
fullstatusbox = aptk.info.FullStatusHBox (cp)

position = aptk.position.HScale (cp)

control = aptk.control.HControl (pl, play_xpmfile = "play.xpm",
				     next_xpmfile = "next.xpm",
				     prev_xpmfile = "prev.xpm",
				     stop_xpmfile = "stop.xpm",
				     relief=GTK.RELIEF_NONE,
				     window=win)
				     
speed = aptk.speed.HSpeed (cp, pause_xpmfile = "pause.xpm",
			       forward_xpmfile = "f_play.xpm",
			       backward_xpmfile = "r_play.xpm",
			       relief=GTK.RELIEF_NONE,
			       window=win)

pan = aptk.pan.HPan (cp, left_xpmfile="l_pan.xpm",
			 right_xpmfile="r_pan.xpm",
			 center_xpmfile="c_pan.xpm",
			 relief=GTK.RELIEF_NONE,
			 window=win)

volume = aptk.volume.HVolume (cp)

##########################################################
main_vbox = gtk.GtkVBox ()
win.add (main_vbox)
main_vbox.add (fullstatusbox)
main_vbox.add (position)

hbox = gtk.GtkHBox ()
main_vbox.add (hbox)
hbox.pack_start (control, expand = gtk.FALSE)

vbox = gtk.GtkVBox ()
hbox.add (vbox)
vbox.add (speed)

hbox2 = gtk.GtkHBox ()
vbox.add (hbox2)
hbox2.add (pan)
hbox2.add (volume)

##########################################################
win.show_all ()
gtk.mainloop ()
