#!/usr/local/bin/alsaplayer-python -I
# panel.py
# Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#   $Id: panel.py,v 1.1 2002/05/16 10:22:49 sjah Exp $
#
 
__author__ = "Evgeny Chukreev <codedj@echo.ru>"
__date__ = "$Date: 2002/05/16 10:22:49 $"
__version__ = "$Revision: 1.1 $"
__license__ = "GNU"

import alsaplayer, aptk, gtk, GTK

pl = alsaplayer.get_playlist ()
cp = pl.get_coreplayer ()

##########################################################
# Main window for test
def delete_event (foo, bar):
    gtk.mainquit ();

win = gtk.GtkWindow ()
win.connect ("delete_event", delete_event)

win.set_title ("AlsaPlayer-Python Panel")
win.set_usize (gtk.screen_width (), 0)
win.set_uposition (0, 0)

##########################################################
class ControlPage (gtk.GtkHBox):
    def __init__ (self, pl, cp):
	gtk.GtkHBox.__init__ (self)

	self.set_spacing (2)
	self.set_border_width (1)

	# - - - - - aptk widgets
	control = aptk.control.HControl (pl, play_xpmfile = "play-sm.xpm",
					     next_xpmfile = "next-sm.xpm",
					     prev_xpmfile = "prev-sm.xpm",
					     stop_xpmfile = "stop-sm.xpm",
					     relief=GTK.RELIEF_NONE,
					     window=win)

	position = aptk.position.HScale (cp)
				     
	speed = aptk.speed.HSpeed (cp, pause_xpmfile = "pause.xpm",
				       forward_xpmfile = "f_play.xpm",
				       backward_xpmfile = "r_play.xpm",
				       relief=GTK.RELIEF_NONE,
				       window=win)

	pan = aptk.pan.HPan (cp, left_xpmfile="l_pan.xpm",
				 right_xpmfile="r_pan.xpm",
				 center_xpmfile="c_pan.xpm",
				 relief=GTK.RELIEF_NONE,
				 window=win)

	volume = aptk.volume.HVolume (cp)

	# - - - - Frames
	control_frame = gtk.GtkFrame ()
	position_frame = gtk.GtkFrame ()
	speed_frame = gtk.GtkFrame ()
	pan_frame = gtk.GtkFrame ()
	volume_frame = gtk.GtkFrame ()

	shadow_type = GTK.SHADOW_OUT
	control_frame.set_shadow_type (shadow_type)
	position_frame.set_shadow_type (shadow_type)
	speed_frame.set_shadow_type (shadow_type)
	pan_frame.set_shadow_type (shadow_type)
	volume_frame.set_shadow_type (shadow_type)

	self.pack_start (control_frame, expand = GTK.FALSE)
	self.add (position_frame)
	self.add (speed_frame)
	self.add (volume_frame)
	self.add (pan_frame)

	# - - - - pack to frames
	control_hbox = gtk.GtkHBox ()
	control_hbox.add (control)
	control_frame.add (control_hbox)
	
	position_frame.add (position)
	speed_frame.add (speed)
	pan_frame.add (pan)
	volume_frame.add (volume)

##########################################################
win.add (ControlPage (pl, cp))

##########################################################
win.show_all ()
gtk.mainloop ()
