#!/usr/local/bin/alsaplayer-python -I
# $Id: mix.py,v 1.1 2002/05/11 00:11:18 sjah Exp $
# Simple script to mix several mp3 files
# Usage: mix.py <file1> <file2> ... <fileN>

import alsaplayer, sys, time

# Clear playlist filled on alsaplayer startup
alsaplayer.get_playlist ().clear ()

# CorePlayer instances list
cps = []

# Create CorePlayer instances... and load mp3 files in
for arg in sys.argv[1:]:
    if arg.lower () [-4:] != ".mp3":  continue

    cp = alsaplayer.CorePlayer ()

    try:
        cp.load (arg)
    except alsaplayer.Error, msg:
	print "Error loading", arg
	del cp
    else:
	cps.append (cp)

# Is there created anything?
if not cps:
    print "No one file loaded"
    sys.exit ()

# Show info about loaded files
for cp in cps:
    si = cp.get_stream_info ()
    print "--------------------------------------------"
    print "Title:", si.title
    print "Artist:", si.artist
    print "Album:", si.album
    print "Genre:", si.genre
    print "Stream type:", si.stream_type
    print "Status", si.status
    print


# Start playing
for cp in cps:  cp.start ()

# Wait while playing
while [1  for cp in cps  if cp.is_playing ()]:
    time.sleep (1)
