#ifndef __PYPLAYLIST_H__
#define __PYPLAYLIST_H__

#include <Python.h>
#include "Playlist.h"
#include "pyplaylistinterface.h"

typedef struct {
    PyObject *instance;
    PyPlaylistInterfaceWrapper *wrapper;
} PyPlaylist_registration;

typedef struct {
    PyObject_HEAD
    Playlist *cobject;
    std::vector<PyPlaylist_registration *> *registered;
    int delondealloc;
} PyPlaylist_Object;

extern PyTypeObject PyPlaylist_Type;

PyPlaylist_Object *PyPlaylist_New (Playlist *playlist, int delondealloc = 0);

#define PyPlaylist_Check(o)    ((o)->ob_type == &PyPlaylist_Type)

#endif
