#ifndef __PYPLAYLISTINTERFACE_H__
#define __PYPLAYLISTINTERFACE_H__

#include <Python.h>
#include <pthread.h>
#include "Playlist.h"

class PyPlaylistInterfaceWrapper: public PlaylistInterface {
    private:
	PyObject *pyobject;
	pthread_mutex_t lock;
    public:
	PyPlaylistInterfaceWrapper (PyObject *obj);
	virtual ~PyPlaylistInterfaceWrapper ();
	void CbSetCurrent(unsigned pos);
	void CbLock();
	void CbUnlock();
	void CbInsert(std::vector<PlayItem> &items, unsigned pos);
	void CbRemove(unsigned start, unsigned end);
	void CbClear();
	void CbUpdated(PlayItem &item, unsigned pos);
};

#endif
