/*  pystreaminfo.cpp
 *  Copyright (C) 2002 Evgeny Chukreev <codedj@echo.ru>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  $Id: pystreaminfo.cpp,v 1.4 2002/05/09 00:10:57 sjah Exp $
 *
*/ 

#include "pystreaminfo.h"

staticforward PyObject *getattr (PyStreamInfo_Object *self, char *name);
staticforward void dealloc (PyStreamInfo_Object *self);

PyTypeObject PyStreamInfo_Type = {
    PyObject_HEAD_INIT (&PyType_Type)
    0,
    "StreamInfo",
    sizeof (PyStreamInfo_Object),
    0,
    (destructor) dealloc,
    0,
    (getattrfunc) getattr,
    0,
    0,
    0,
    0,
    0,
    0,
    0,
};

// ##############################################################
// ##############################################################
static PyMethodDef methods[] = {
    {NULL, NULL}
};

// ///////////////////////////////////////////////////////////////////
static PyObject *getattr (PyStreamInfo_Object *self, char *name)
{   
    // MEMBERS
    if (!strcmp (name, "__members__"))
	return Py_BuildValue ("(s,s,s,s,s,s)", "stream_type", "title",
			      "artist", "status", "album", "genre");
 
    // -- filename member
    if (!strcmp (name, "stream_type"))
	return Py_BuildValue ("s", self->cstruct.stream_type);

    // -- title member
    if (!strcmp (name, "title"))
	return Py_BuildValue ("s", self->cstruct.title);

    // -- album member
    if (!strcmp (name, "album"))
	return Py_BuildValue ("s", self->cstruct.album);

    // -- genre member
    if (!strcmp (name, "genre"))
	return Py_BuildValue ("s", self->cstruct.genre);
    
    // -- artist member
    if (!strcmp (name, "artist"))
	return Py_BuildValue ("s", self->cstruct.artist);

    // -- playtime member
    if (!strcmp (name, "status"))
	return Py_BuildValue ("s", self->cstruct.status);
 
    // METHOD
    return Py_FindMethod (methods, (PyObject*)self, name);
}

// DESTRUCTOR -- - -- -- ---- - - - - -- - - - - - -
static void dealloc (PyStreamInfo_Object *self)
{
    PyObject_Del (self);
}

// Object creation function -  - - - - - - - - - - - - - - - - - - -
PyStreamInfo_Object *PyStreamInfo_New (void)
{
    PyStreamInfo_Object *pystreaminfo;

    pystreaminfo = PyObject_New (PyStreamInfo_Object, &PyStreamInfo_Type);

    // Init
    pystreaminfo->cstruct.title[0] = '\0';
    pystreaminfo->cstruct.album[0] = '\0';
    pystreaminfo->cstruct.genre[0] = '\0';
    pystreaminfo->cstruct.artist[0] = '\0';
    pystreaminfo->cstruct.status[0] = '\0';
    pystreaminfo->cstruct.stream_type[0] = '\0';

    return pystreaminfo;
}
